//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vhudson-jaxb-ri-2.2-147 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2020.03.06 at 12:22:27 AM EET 
//


package org.xbrl._2003.instance;

import java.util.HashMap;
import java.util.Map;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyAttribute;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlIDREF;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.XmlValue;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import javax.xml.namespace.QName;
import org.xbrl._int.gl.bus._2016_12_01.AccountantEngagementTypeItemType;
import org.xbrl._int.gl.bus._2016_12_01.AccountingMethodItemType;
import org.xbrl._int.gl.bus._2016_12_01.AccountingMethodPurposeItemType;
import org.xbrl._int.gl.bus._2016_12_01.BudgetAllocationCodeItemType;
import org.xbrl._int.gl.bus._2016_12_01.DmJurisdictionTypeItemType;
import org.xbrl._int.gl.bus._2016_12_01.MeasurableCodeItemType;
import org.xbrl._int.gl.bus._2016_12_01.MeasurableQualifierItemType;
import org.xbrl._int.gl.bus._2016_12_01.PeriodUnitTypeItemType;
import org.xbrl._int.gl.bus._2016_12_01.ReportingCalendarOpenClosedStatusItemType;
import org.xbrl._int.gl.bus._2016_12_01.ReportingCalendarPeriodTypeItemType;
import org.xbrl._int.gl.cor._2016_12_01.AccountSubTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.AccountPurposeCodeItemType;
import org.xbrl._int.gl.gen._2016_12_01.AccountTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.BookTaxDifferenceItemType;
import org.xbrl._int.gl.gen._2016_12_01.DebitCreditCodeItemType;
import org.xbrl._int.gl.gen._2016_12_01.DocumentTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.EntriesTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.EntryTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.IdentifierOrganizationTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.IdentifierTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.InvoiceTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.MainAccountTypeItemType;
import org.xbrl._int.gl.gen._2016_12_01.PhoneNumberDescriptionItemType;
import org.xbrl._int.gl.gen._2016_12_01.PostingStatusItemType;
import org.xbrl._int.gl.gen._2016_12_01.QualifierEntryItemType;
import org.xbrl._int.gl.gen._2016_12_01.RevisesUniqueIDActionItemType;
import org.xbrl._int.gl.gen._2016_12_01.SignOfAmountItemType;
import org.xbrl._int.gl.gen._2016_12_01.SourceJournalIDItemType;
import org.xbrl._int.gl.gen._2016_12_01.XbrlIncludeItemType;


/**
 * <p>Java class for tokenItemType complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="tokenItemType">
 *   &lt;simpleContent>
 *     &lt;extension base="&lt;http://www.w3.org/2001/XMLSchema>token">
 *       &lt;attGroup ref="{http://www.xbrl.org/2003/instance}nonNumericItemAttrs"/>
 *     &lt;/extension>
 *   &lt;/simpleContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "tokenItemType", propOrder = {
    "value"
})
@XmlSeeAlso({
    SignOfAmountItemType.class,
    MainAccountTypeItemType.class,
    PhoneNumberDescriptionItemType.class,
    SourceJournalIDItemType.class,
    IdentifierOrganizationTypeItemType.class,
    IdentifierTypeItemType.class,
    QualifierEntryItemType.class,
    RevisesUniqueIDActionItemType.class,
    DebitCreditCodeItemType.class,
    InvoiceTypeItemType.class,
    EntryTypeItemType.class,
    AccountTypeItemType.class,
    BookTaxDifferenceItemType.class,
    XbrlIncludeItemType.class,
    EntriesTypeItemType.class,
    DocumentTypeItemType.class,
    AccountSubTypeItemType.class,
    AccountPurposeCodeItemType.class,
    PostingStatusItemType.class,
    PeriodUnitTypeItemType.class,
    AccountantEngagementTypeItemType.class,
    AccountingMethodPurposeItemType.class,
    AccountingMethodItemType.class,
    DmJurisdictionTypeItemType.class,
    ReportingCalendarPeriodTypeItemType.class,
    BudgetAllocationCodeItemType.class,
    MeasurableQualifierItemType.class,
    ReportingCalendarOpenClosedStatusItemType.class,
    MeasurableCodeItemType.class
})
public class TokenItemType {

    @XmlValue
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    @XmlSchemaType(name = "token")
    protected String value;
    @XmlAttribute(name = "contextRef")
    protected String contextRef;
    @XmlAttribute(name = "id")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    @XmlID
    @XmlSchemaType(name = "ID")
    protected String id;
    @XmlAnyAttribute
    private Map<QName, String> otherAttributes = new HashMap<QName, String>();

    /**
     * Gets the value of the value property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getValue() {
        return value;
    }

    /**
     * Sets the value of the value property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setValue(String value) {
        this.value = value;
    }

    /**
     * Gets the value of the contextRef property.
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public String getContextRef() {
        return contextRef;
    }

    /**
     * Sets the value of the contextRef property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setContextRef(String value) {
        this.contextRef = value;
    }

    /**
     * Gets the value of the id property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setId(String value) {
        this.id = value;
    }

    /**
     * Gets a map that contains attributes that aren't bound to any typed property on this class.
     * 
     * <p>
     * the map is keyed by the name of the attribute and 
     * the value is the string value of the attribute.
     * 
     * the map returned by this method is live, and you can add new attribute
     * by updating the map directly. Because of this design, there's no setter.
     * 
     * 
     * @return
     *     always non-null
     */
    public Map<QName, String> getOtherAttributes() {
        return otherAttributes;
    }

}
